unit Makegl1;
{*********************************************************************
 *  Hauptprogramm zum "MakeHPGL"                        Date: 01.03.99
 *  (c) M. Magnin
 *********************************************************************
 *  Datei            : MakeGL1.pas
 *  Version          : 0.0 (beta01)
 *  letzte Aenderung : 12.03.99
 *********************************************************************
 *  Kommentar:
 *  Das Programm wurde kommpiliert mit Delphi V4.0 standard.
 *********************************************************************
 *  Datum nderungen
 *  09.03.99  Spiegeln von BMP's erstellt
 *            SP1 im HP-GL Begin eingefgt (fr Corel)
 *            Skalierung von HP-GL aus Pixel eingefgt
 *  10.03.99  Vektorisieren nach Grauwerten
 *            Konturen gltten, Farben invertieren
 *            Default Grafik Grsse fr [Datei] [Neu] = 800x600
 *  15.09.99  Speichern im DXF Vektor-Format
 *  18.09.99  InLine Vektorisieren implementieren
 *  26.09.99  Weg Optimierung der Vektoren
 *********************************************************************}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  Infos1, ImageDisp,
  Menus, ExtCtrls, StdCtrls, Printers;

{ Die Proceduren und Funktionen werden beim Code beschrieben }
type
  TMakeGL = class(TForm)
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Ansicht: TMenuItem;
    Hilfe1: TMenuItem;
    MenuNeu: TMenuItem;
    MenuOffnen: TMenuItem;
    MenuSpeichern: TMenuItem;
    MenuSpeichernunter: TMenuItem;
    MenuLeer1: TMenuItem;
    MenuUbermittelnCNC: TMenuItem;
    MenuDrucken: TMenuItem;
    MenuLeer2: TMenuItem;
    MenuBeenden: TMenuItem;
    MenuHilfeThemen: TMenuItem;
    MenuLeer3: TMenuItem;
    MenuInfo: TMenuItem;
    MenuVorschau: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    PrintDialog: TPrintDialog;
    Bearbeiten: TMenuItem;
    MenuKopieren: TMenuItem;
    MenuEinfgen: TMenuItem;
    BufferNutzText: TLabel;
    BuffNutz: TLabel;
    MitteilungText: TLabel;
    Mitteilung: TLabel;
    MenuKonvert: TMenuItem;
    MenuBMPBohrsuchen: TMenuItem;
    MenuBMPOutLineVekt: TMenuItem;
    Menuabtasten: TMenuItem;
    Menuabtastenneg: TMenuItem;
    MenuBild: TMenuItem;
    MenuSpiegeln: TMenuItem;
    MenuToMono: TMenuItem;
    MenuSkalier: TMenuItem;
    MneuGrauWert: TMenuItem;
    MenuInvert: TMenuItem;
    MenuGlaten: TMenuItem;
    MenuBMPInLineVekt: TMenuItem;
    MenuWegOpt: TMenuItem;
    Procedure MenuInfoClick(Sender: TObject);
    Procedure MenuBeendenClick(Sender: TObject);
    Procedure MenuOffnenClick(Sender: TObject);
    Procedure MenuNeuClick(Sender: TObject);
    Procedure MenuSpeichernClick(Sender: TObject);
    Procedure MenuSpeichernunterClick(Sender: TObject);
    Procedure Init(Sender: TObject);
    Procedure MenuDruckenClick(Sender: TObject);
    Procedure MenuVorschauClick(Sender: TObject);
    Procedure ScanImg;
    Function  ScanImgCirc(XX,YY: LongInt):LongInt;
    Procedure DrawImg;
    Procedure SaveData(FileName:String);
    procedure MenuHilfeThemenClick(Sender: TObject);
    procedure MenuKopierenClick(Sender: TObject);
    procedure MenuEinfgenClick(Sender: TObject);
    procedure MenuUbermittelnCNCClick(Sender: TObject);
    Procedure ScanOutLine;
    Function  ScanWurm(Xs,Ys,Linie:LongInt):LongInt;
    Function  GetAngel(X,Y,XX,YY:LongInt):LongInt;
    Procedure BMPAbtasten;
    Procedure BMPAbtastNeg;
    Procedure MenuBMPBohrsuchenClick(Sender: TObject);
    Procedure MenuBMPOutLineVektClick(Sender: TObject);
    Procedure MenuabtastenClick(Sender: TObject);
    Procedure MenuabtastennegClick(Sender: TObject);
    Procedure MenuToMonoClick(Sender: TObject);
    Procedure MakeMono;
    Procedure MenuSpiegelnClick(Sender: TObject);
    Procedure BMPSpiegeln;
    Procedure MenuSkalierClick(Sender: TObject);
    Procedure BMPScale;
    Procedure MenuGrauWertClick(Sender: TObject);
    Procedure MenuInvertClick(Sender: TObject);
    Procedure MenuGlatenClick(Sender: TObject);
    Procedure SaveAsDXF(FileName: String);
    Procedure MenuBMPInLineVektClick(Sender: TObject);
    Procedure MenuWegOptClick(Sender: TObject);
    Function  VektorDistanz(StrHPGLVon,StrHPGLBis:String):LongInt;



  private    { Private-Deklarationen }
  public     { Public-Deklarationen objekt orientiert z.B. MakeHPGL.Titel }
  end;

Const Titel        = 'Make HPGL';           { Fr Open und Close Dialog }
      Vers         = 'V0.01';               { Fr Info Box }
      Dat          = 'Sept 1999';
      Rights       = 'Copyright By SYSTEM-CLINCH Aadorf';
      InfosTxt     = 'Infos http://www.clinch.ch oder Info@clinch.net';
      DataMax      = 50000;                 { Max Anzahl Linien im Buffer }
      HelpFile     = 'MakeHPGL.hlp';        { Notwendig Dateien }
      AppIni       = 'MakeHPGL.ini';
      TempFileName = 'MakeHPGL.TMP';
      PrtFak       = 3;                     { Stretch der Printer-Ausgabe }
      Skalier100mm = 3939;                  { 100mm sind 3939 HPGL Einheiten }

var   MakeGL: TMakeGL;
      Data     : Array[0..DataMax] of String[40];   { Buffer }
      AppPath  : String[45];                { Programm Path mit \ am ende inkl. Drive }
      Raster   : Word;                      { Abtsten von BMPs fr Bohrlcher}
      RasterHor: Word;                      { Abtsten von BMPs fr Horizontal Vektorisieren}
      CountMax : Word;                      { geht mit max150 min10 }
      CountMin : Word;                      { geht mit max60 min10 }
      BMPXFAK  : Word;                      { Fakto X fr BMPs opt = 30}
      BMPYFAK  : Word;                      { Fakto Y fr BMPs opt = 30}
      WinkelDif : Word;                     { Winkelfehler fr Polilinie opt = 2}
      PixProLinie : Word;                   { Anzahl Pixels die eine Frslinie Bilden (Abtasten) Opt=1}
      PixProMM : Word;                      { anz Pixels ist ein mm (fr Bohr-Loch) opt=4}
      I        : Word;                      { algemeine Nutzung }
      MausPos  : TPoint;                    { Maus Position auf der Grafik }

implementation

uses ClipBrd,IniFiles;

{$R *.DFM}

{ About Box anzeigen }
procedure TMakeGL.MenuInfoClick(Sender: TObject);
Var  MS: TMemoryStatus;
begin
  Infos.Show;
  Infos.Caption             := Titel + ' Infos';
  Infos.ProduktName.Caption := Titel;
  Infos.Version.caption     := Vers + ' vom '+ Dat;
  Infos.Copyright.caption   := Rights;
  Infos.Comments.caption    := InfosTxt;
  GlobalMemoryStatus(MS);
  Infos.MemoryText.Caption := FormatFloat('Arbeitsspeicher gesamt:  #,###" KB"', MS.dwTotalPhys / 1024);
end;

{ Programm verlassen }
procedure TMakeGL.MenuBeendenClick(Sender: TObject);
begin
  MakeGL.Close;
end;

{ Datei ffnen }
procedure TMakeGL.MenuOffnenClick(Sender: TObject);
var    DateiHandel : file of Byte;
       Linie       : LongInt;
       LinieStr    : String[100];
       DataByte    : Byte;
       StrX, StrY  : String[100];
       N,Dummy     : LongInt;
Begin
  With OpenDialog Do
    If Execute Then
    Begin
      AssignFile(DateiHandel, OpenDialog.FileName); {Test if Exist}
      {$i-}Reset(DateiHandel);{$i+}
      {SizeOfFile := FileSize(DateiHandel);}                         { Testen der Dateigrsse nicht ntig}
      If IOResult <> 0 Then Begin;                                   { Fehler abfangen }
        ShowMessage('Fehler beim ffnen von: '+FileName);
        Exit;
      End;
      Mitteilung.Caption := 'Lade: '+ExtractFilename(FileName);
      CloseFile(DateiHandel);
      If Copy(OpenDialog.FileName,Length(OpenDialog.FileName)-3,4)='.bmp' Then Begin;  { Ist es ein Bild }
        Caption := Titel + ' - '+ ExtractFilename(FileName);
        ImageDispForm.Caption := Titel + ' - '+ ExtractFilename(OpenDialog.FileName);
        ImageDispForm.Image.Picture.LoadFromFile(OpenDialog.FileName);
{       ImageDispForm.image.Picture.Bitmap.PixelFormat := pf4bit;    { konvertiere auf 16-Farben }
        {ScanImg; }                                                  { Abtasten nicht automatisch }
      End Else Begin;                                                { Es ein Text File }
        Linie := 0;                                                  { Start im Buffer }
        Caption := Titel + ' - '+ ExtractFilename(FileName);
        AssignFile(DateiHandel, OpenDialog.FileName);
        Reset(DateiHandel);
        Data[Linie] := 'PU;';                                        { HP-GL Buffer initialisierung }
        Inc(Linie);
        Data[Linie] := 'SP1;';
        Inc(Linie);
        While (Not EOF(DateiHandel)) And (Linie<DataMax) do Begin    { Bis Datei-Ende oder Buffer Ende }
          LinieStr:='';
          Repeat;                                                    { Zeile Bilden }
            Read(DateiHandel,DataByte);
            If (DataByte<>10) And (DataByte<>13) Then LinieStr:=LinieStr+Chr(DataByte);
          Until EOF(DateiHandel) Or (Length(LinieStr)>99) Or (DataByte=13) Or
                (DataByte=59) Or (DataByte=13) Or (DataByte=10);

          If Length(LinieStr)>2 Then Begin;                          { Komische sonder Zeichen LFs ... weg }
            { EXCELLON }
            If (Copy(LinieStr,1,1)='X') Or (Copy(LinieStr,1,1)='X') Then Begin;                  { X begin is OK }
              If (Copy(LinieStr,1,1)='X') Then Begin;                { X begin is OK }
                 If Pos('Y',LinieStr)>0 Then N:=Pos('Y',LinieStr) Else N:=20;
                 Val(Copy(LinieStr,2,N-2),N,Dummy);
                 Str(Round((6000+N)*2),StrX);
              End;
              If Pos('Y',LinieStr)>0 Then Begin;                     { Y beginn }
                Val(Copy(LinieStr,Pos('Y',LinieStr)+1,10),N,Dummy);
                 Str(Round((5000+N)*2),StrY);
              End;
              { mili Inch zu mm :: mInch/100*2.54=mm }  { 100mm = 3939 HPGL Einheiten }
              Data[Linie] := 'PA'+StrX+','+StrY+';';                 { Vektor erstellen }
              Inc(Linie);
              Data[Linie] := 'PD;';                                  { Bohrung auslsen }
              Inc(Linie);
              Data[Linie] := 'PU;';
              Inc(Linie);
            End;
            { Excellon Bohrer wechseln }
            If (Copy(LinieStr,1,1)='T') And (Pos('C',LinieStr)=0) Then Begin;
              Data[Linie] := 'PU;';
              Inc(Linie);
              Data[Linie] := 'DSBitte Bohrer: '+Copy(LinieStr,2,2)+' einlegen;';
              Inc(Linie);
              Data[Linie] := 'WK;';
              Inc(Linie);
            End;
            { Excellon Bohrer Liste }
            If (Copy(LinieStr,1,1)='T') And (Pos('C',LinieStr)>0) Then Begin;
              Data[Linie] := 'PU;';
              Inc(Linie);
              Data[Linie] := 'DSBohrer Liste;';
              Inc(Linie);
            End;
            {HP-GL}
            If Copy(LinieStr,1,2)='SP' Then Begin;
              StrX:=Copy(LinieStr,3,1);
              Data[Linie] := 'SP'+StrX+';';
              Inc(Linie);
            End;
            If (Copy(LinieStr,1,2)='PD') Or (Copy(LinieStr,1,2)='PU') Or
               (Copy(LinieStr,1,2)='PA') Then Begin;
              N:=Pos(',',LinieStr);
              If N=0 Then N:=Pos(' ',LinieStr);
              StrX := Copy(LinieStr,3,N-3);
              StrY := Copy(LinieStr,N+1,30);
              If Copy(StrY,Length(StrY),1)=';' Then
                StrY:=Copy(StrY,1,Length(StrY)-1);
              If (Copy(LinieStr,1,2)='PD') Or (Copy(LinieStr,1,2)='PU') Then Begin;
                Data[Linie] := Copy(LinieStr,1,2)+';';
                Inc(Linie);
              End;
              If (Copy(LinieStr,1,2)='PA') Then Begin;
                Data[Linie] := 'PA'+StrX+','+StrY+';';
                Inc(Linie);
              End;
            End;
          End;
          If Linie Mod 1000 = 0 Then Begin;                       { Alle 1000 Zeilen Windows frei geben }
            Application.ProcessMessages;
            Str(Round(Linie/DataMax*100),StrX);
            BuffNutz.Caption := StrX+' %';
          End;
        End;
        Data[Linie] := 'PU;';                                     { Buffer ende ausgeben }
        Inc(Linie);
        Data[Linie] := 'SP0;';
        Inc(Linie);
        Data[Linie]:='ENDE';                                      { Buffer end Merker }
        Str(Round(Linie/DataMax*100),StrX);
        BuffNutz.Caption := StrX+' %';
        CloseFile(DateiHandel);
        DrawImg;                                                  { Vektor Bild Zeichnen }
      End;
    end;
  Mitteilung.Caption := 'geladen: '+ExtractFilename(OpenDialog.FileName);
end;

{ Datei Neu alle Buffer lschen }
Procedure TMakeGL.MenuNeuClick(Sender: TObject);
Begin
  OpenDialog.Filename := '';
  Data[0]:='ENDE';
  Caption := Titel + ' - [Namenlos]';
  ImageDispForm.Caption := Titel + ' - [Namenlos]';
  ImageDispForm.Image.Canvas.Create;
  { und neue Grsse festlegen }
  ImageDispForm.Image.Picture.BitMap.Width := 800;
  ImageDispForm.Image.Picture.BitMap.Height := 600;
  { und Grafik-Schirm lschen }
  PatBlt(ImageDispForm.Image.Canvas.Handle,0,0,
         ImageDispForm.Image.Width-1,ImageDispForm.Image.Height-1,Whiteness);
  ImageDispForm.Image.Refresh;
  Mitteilung.Caption := 'Bereit';
  BuffNutz.Caption := '0 %';
End;

{ Save File Bild oder Vektor }
Procedure TMakeGL.SaveData(FileName:String);
Var Linie : LongInt;
    LinieStr : String[100];
    DateiHandel : TextFile;
Begin;
  Linie := 0;
  MakeGL.Caption := Titel + ' - ' + ExtractFilename(FileName);
  ImageDispForm.Caption := Titel + ' - ' + ExtractFilename(FileName);
  Mitteilung.Caption := 'gespeichert: ' + ExtractFilename(FileName);
  If SaveDialog.FilterIndex=1 Then Begin;
    If Pos('.',FileName)=0 Then FileName:=FileName+'.plt'; { Ist erweiterung da }
    AssignFile(DateiHandel, FileName);
    {$i-}ReWrite(DateiHandel);{$i+}
    If IOResult <> 0 Then Begin;
      ShowMessage('Fehler beim Speichern von: '+FileName);
      Exit;
    End;
    While (Data[Linie]<>'ENDE') do Begin
      LinieStr:=Data[Linie];
      WriteLn(DateiHandel,LinieStr);
      Inc(Linie);
    End;
    CloseFile(DateiHandel);
  End;
  If SaveDialog.FilterIndex=2 Then Begin;
    If Pos('.',FileName)=0 Then FileName:=FileName+'.bmp'; { Ist erweiterung da }
    AssignFile(DateiHandel, FileName);
    {$i-}ReWrite(DateiHandel);{$i+}
    If IOResult <> 0 Then Begin;
      ShowMessage('Fehler beim Speichern von: '+FileName);
      Exit;
    End;
    CloseFile(DateiHandel);
    ImageDispForm.Caption := Titel + ' - '+ ExtractFilename(FileName);
    ImageDispForm.Image.Picture.SaveToFile(FileName);
  End;
  If SaveDialog.FilterIndex=3 Then Begin;
    If Pos('.',FileName)=0 Then FileName:=FileName+'.dxf'; { Ist erweiterung da }
    AssignFile(DateiHandel, FileName);
    {$i-}ReWrite(DateiHandel);{$i+}
    If IOResult <> 0 Then Begin;
      ShowMessage('Fehler beim Speichern von: '+FileName);
      Exit;
    End;
    CloseFile(DateiHandel);
    SaveAsDXF(FileName);
  End;
End;

Procedure TMakeGL.SaveAsDXF(FileName: String);
Var   St100    : String[100];
      CR       : String[10];
      Color    : String[4];
      Linie    : LongInt;
      LinieStr : String[100];
      DateiHandel : TextFile;
Begin;
  Linie := 0;
  Color := '7';
  CR := Chr(10);
    AssignFile(DateiHandel, FileName);
    {$i-}ReWrite(DateiHandel);{$i+}
    { Header Section }
    WriteLn(DateiHandel,'999'+CR+'DXF erstellt mit '+
            Titel+' '+Vers+' '+Dat);
    WriteLn(DateiHandel,'0'+CR+'SECTION');
    WriteLn(DateiHandel,'2'+CR+'HEADER');
    WriteLn(DateiHandel,'9'+CR+'$LTSCALE');
    WriteLn(DateiHandel,'40'+CR+'20.000000');
    WriteLn(DateiHandel,'9'+CR+'$LIMMIN');   { Null Punkt }
    WriteLn(DateiHandel,'10'+CR+'0.0');
    WriteLn(DateiHandel,'20'+CR+'0.0');
    WriteLn(DateiHandel,'9'+CR+'$LIMMAX');   { Max Punkt }
    WriteLn(DateiHandel,'10'+CR+'2970.0');
    WriteLn(DateiHandel,'20'+CR+'2100.0');
    WriteLn(DateiHandel,'9'+CR+'$EXTMIN');   { Null Punkt ext }
    WriteLn(DateiHandel,'10'+CR+'0.0');
    WriteLn(DateiHandel,'20'+CR+'0.0');
    WriteLn(DateiHandel,'9'+CR+'$EXTMAX');   { Max Punkt ext }
    WriteLn(DateiHandel,'10'+CR+'2970.0');
    WriteLn(DateiHandel,'20'+CR+'2100.0');
    WriteLn(DateiHandel,'9'+CR+'$SNAPMODE');  { SNAP }
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'9'+CR+'$SNAPUNIT');
    WriteLn(DateiHandel,'10'+CR+'10.000');
    WriteLn(DateiHandel,'20'+CR+'10.000');
    WriteLn(DateiHandel,'9'+CR+'$GRIDMODE');   { GRID }
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'9'+CR+'$GRIDUNIT');
    WriteLn(DateiHandel,'10'+CR+'10.000');
    WriteLn(DateiHandel,'20'+CR+'10.000');
    WriteLn(DateiHandel,'9'+CR+'$ORTHOMODE');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'9'+CR+'$TEXTSTYLE');
    WriteLn(DateiHandel,'7'+CR+'txt');
    WriteLn(DateiHandel,'9'+CR+'$CLAYER');
    WriteLn(DateiHandel,'8'+CR+'1');
    WriteLn(DateiHandel,'9'+CR+'$CECOLOR');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'9'+CR+'$CELTYPE');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'9'+CR+'$PLINEWID');
    WriteLn(DateiHandel,'40'+CR+'0.0000');
    WriteLn(DateiHandel,'9'+CR+'$OSMODE');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'9'+CR+'$FILLMODE');
    WriteLn(DateiHandel,'70'+CR+'1');
    WriteLn(DateiHandel,'9'+CR+'$CHAMFERA');
    WriteLn(DateiHandel,'40'+CR+'10.0000');
    WriteLn(DateiHandel,'9'+CR+'$CHAMFERB');
    WriteLn(DateiHandel,'40'+CR+'10.0000');
    WriteLn(DateiHandel,'9'+CR+'$COORDS');
    WriteLn(DateiHandel,'70'+CR+'1');
    WriteLn(DateiHandel,'9'+CR+'$FILLETRAD');
    WriteLn(DateiHandel,'40'+CR+'10.0000');
    WriteLn(DateiHandel,'9'+CR+'$INSBASE');
    WriteLn(DateiHandel,'10'+CR+'0.000');
    WriteLn(DateiHandel,'20'+CR+'0.000');
    WriteLn(DateiHandel,'9'+CR+'$SPLFRAME');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'9'+CR+'$SPLINESEGS');
    WriteLn(DateiHandel,'70'+CR+'8');
    WriteLn(DateiHandel,'0'+CR+'ENDSEC');

    { Table Section }
    WriteLn(DateiHandel,'0'+CR+'SECTION');
    WriteLn(DateiHandel,'2'+CR+'TABLES');
    WriteLn(DateiHandel,'0'+CR+'TABLE');
    WriteLn(DateiHandel,'2'+CR+'LTYPE');
    WriteLn(DateiHandel,'70'+CR+'9');
    WriteLn(DateiHandel,'0'+CR+'LTYPE');             { Linien Definition }
    WriteLn(DateiHandel,'2'+CR+'GESTRICHELT');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'3'+CR+'__ __ __ __ __ __ __ __ __ __ __ __ __ __ _');
    WriteLn(DateiHandel,'72'+CR+'65');
    WriteLn(DateiHandel,'73'+CR+'2');
    WriteLn(DateiHandel,'40'+CR+'0.750000');
    WriteLn(DateiHandel,'49'+CR+'0.500000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'0'+CR+'LTYPE');             { Linien Definition }
    WriteLn(DateiHandel,'2'+CR+'VERDECKT');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'3'+CR+'_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _');
    WriteLn(DateiHandel,'72'+CR+'65');
    WriteLn(DateiHandel,'73'+CR+'2');
    WriteLn(DateiHandel,'40'+CR+'0.250000');
    WriteLn(DateiHandel,'49'+CR+'0.125000');
    WriteLn(DateiHandel,'49'+CR+'-0.125000');
    WriteLn(DateiHandel,'0'+CR+'LTYPE');             { Linien Definition }
    WriteLn(DateiHandel,'2'+CR+'MITTELLINIE');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'3'+CR+'____ _ ____ _ ____ _ ____ _ ____ _ ____ _ __');
    WriteLn(DateiHandel,'72'+CR+'65');
    WriteLn(DateiHandel,'73'+CR+'4');
    WriteLn(DateiHandel,'40'+CR+'2.000000');
    WriteLn(DateiHandel,'49'+CR+'1.250000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'49'+CR+'0.250000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'0'+CR+'LTYPE');             { Linien Definition }
    WriteLn(DateiHandel,'2'+CR+'PHANTOM');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'3'+CR+'_____ _ _ _____ _ _ _____ _ _ _____ _ _ ____');
    WriteLn(DateiHandel,'72'+CR+'65');
    WriteLn(DateiHandel,'73'+CR+'6');
    WriteLn(DateiHandel,'40'+CR+'2.500000');
    WriteLn(DateiHandel,'49'+CR+'1.250000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'49'+CR+'0.250000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'49'+CR+'0.250000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'0'+CR+'LTYPE');             { Linien Definition }
    WriteLn(DateiHandel,'2'+CR+'PUNKTIERT');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'3'+CR+'............................................');
    WriteLn(DateiHandel,'72'+CR+'65');
    WriteLn(DateiHandel,'73'+CR+'2');
    WriteLn(DateiHandel,'40'+CR+'0.250000');
    WriteLn(DateiHandel,'49'+CR+'0.000000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'0'+CR+'LTYPE');             { Linien Definition }
    WriteLn(DateiHandel,'2'+CR+'STRICHPUNKTIERT');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'3'+CR+'__ . __ . __ . __ . __ . __ . __ . __ . __ .');
    WriteLn(DateiHandel,'72'+CR+'65');
    WriteLn(DateiHandel,'73'+CR+'4');
    WriteLn(DateiHandel,'40'+CR+'1.000000');
    WriteLn(DateiHandel,'49'+CR+'0.500000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'49'+CR+'0.000000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'0'+CR+'LTYPE');             { Linien Definition }
    WriteLn(DateiHandel,'2'+CR+'RAND');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'3'+CR+'__ __ . __ __ . __ __ . __ __ . __ __ . __ _');
    WriteLn(DateiHandel,'72'+CR+'65');
    WriteLn(DateiHandel,'73'+CR+'6');
    WriteLn(DateiHandel,'40'+CR+'1.750000');
    WriteLn(DateiHandel,'49'+CR+'0.500000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'49'+CR+'0.500000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'49'+CR+'0.000000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'0'+CR+'LTYPE');             { Linien Definition }
    WriteLn(DateiHandel,'2'+CR+'TRENNLINIE');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'3'+CR+'__ . . __ . . __ . . __ . . __ . . __ . . __');
    WriteLn(DateiHandel,'72'+CR+'65');
    WriteLn(DateiHandel,'73'+CR+'6');
    WriteLn(DateiHandel,'40'+CR+'1.250000');
    WriteLn(DateiHandel,'49'+CR+'0.500000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'49'+CR+'0.000000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'49'+CR+'0.000000');
    WriteLn(DateiHandel,'49'+CR+'-0.250000');
    WriteLn(DateiHandel,'0'+CR+'LTYPE');             { Linien Definition }
    WriteLn(DateiHandel,'2'+CR+'ENG_PUNKTIERT');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'3'+CR+'schlieen');
    WriteLn(DateiHandel,'72'+CR+'65');
    WriteLn(DateiHandel,'73'+CR+'2');
    WriteLn(DateiHandel,'40'+CR+'0.100000');
    WriteLn(DateiHandel,'49'+CR+'0.050000');
    WriteLn(DateiHandel,'49'+CR+'-0.050000');
    WriteLn(DateiHandel,'0'+CR+'ENDTAB');         { Ende Linien Definition}

    WriteLn(DateiHandel,'0'+CR+'TABLE');
    WriteLn(DateiHandel,'2'+CR+'STYLE');
    WriteLn(DateiHandel,'70'+CR+'1');
    WriteLn(DateiHandel,'0'+CR+'STYLE');
    WriteLn(DateiHandel,'2'+CR+'STANDARD');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'40'+CR+'0.000000');
    WriteLn(DateiHandel,'41'+CR+'1.000000');
    WriteLn(DateiHandel,'50'+CR+'0.000000');
    WriteLn(DateiHandel,'71'+CR+'0');
    WriteLn(DateiHandel,'42'+CR+'0.200000');
    WriteLn(DateiHandel,'3'+CR+'txt');
    WriteLn(DateiHandel,'4'+CR+' ');
    WriteLn(DateiHandel,'0'+CR+'ENDTAB');

    { Sektion Layer }
    WriteLn(DateiHandel,'0'+CR+'TABLE');
    WriteLn(DateiHandel,'2'+CR+'LAYER');
    WriteLn(DateiHandel,'70'+CR+'10');
    WriteLn(DateiHandel,'0'+CR+'LAYER');        { Layer 1 definition }
    WriteLn(DateiHandel,'2'+CR+'1');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'0'+CR+'LAYER');        { Layer 2 definition }
    WriteLn(DateiHandel,'2'+CR+'2');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'0'+CR+'LAYER');
    WriteLn(DateiHandel,'2'+CR+'3');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'0'+CR+'LAYER');
    WriteLn(DateiHandel,'2'+CR+'4');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'0'+CR+'LAYER');
    WriteLn(DateiHandel,'2'+CR+'5');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'0'+CR+'LAYER');
    WriteLn(DateiHandel,'2'+CR+'6');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'0'+CR+'LAYER');
    WriteLn(DateiHandel,'2'+CR+'7');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'0'+CR+'LAYER');
    WriteLn(DateiHandel,'2'+CR+'8');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'0'+CR+'LAYER');
    WriteLn(DateiHandel,'2'+CR+'9');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'0'+CR+'LAYER');        { Layer 10 definition }
    WriteLn(DateiHandel,'2'+CR+'10');
    WriteLn(DateiHandel,'70'+CR+'0');
    WriteLn(DateiHandel,'62'+CR+'7');
    WriteLn(DateiHandel,'6'+CR+'CONTINUOUS');
    WriteLn(DateiHandel,'0'+CR+'ENDTAB');
    WriteLn(DateiHandel,'0'+CR+'ENDSEC');

    { Block Bereich 8Leer) }
    WriteLn(DateiHandel,'0'+CR+'SECTION');
    WriteLn(DateiHandel,'2'+CR+'BLOCKS');
    WriteLn(DateiHandel,'0'+CR+'ENDSEC');

    { Geometrie Elemente }
    WriteLn(DateiHandel,'0'+CR+'SECTION');
    WriteLn(DateiHandel,'2'+CR+'ENTITIES');
    { Geometrische Daten hier }
    WriteLn(DateiHandel,'0'+CR+'LINE');  { Linie }
    WriteLn(DateiHandel,'62'+CR+Color);  { Farbe }
    WriteLn(DateiHandel,'8'+CR+'1');     { Layer }
    WriteLn(DateiHandel,'10'+CR+'0');    { X1-Vektoren }
    WriteLn(DateiHandel,'20'+CR+'0');    { Y1-Vektoren }
{    WriteLn(DateiHandel,'30'+CR+'0');    { Z1-Vektoren }
    WriteLn(DateiHandel,'11'+CR+'0');    { X2-Vektoren }
    WriteLn(DateiHandel,'21'+CR+'0');    { Y2-Vektoren }
{    WriteLn(DateiHandel,'31'+CR+'0');    { Z2-Vektoren }

    ST100:='PU';
    While (Data[Linie]<>'ENDE') do Begin
      LinieStr:=Data[Linie];
      If Copy(LinieStr,1,2)='SP' Then Color:=Copy(LinieStr,3,1);
      If Copy(LinieStr,1,2)='PU' Then ST100:='PU';
      If Copy(LinieStr,1,2)='PD' Then ST100:='PD';
      If Copy(LinieStr,1,2)='PA' Then ST100:='PD';
      If (Copy(LinieStr,1,2)='PA') And (ST100='PD') Then Begin;
        WriteLn(DateiHandel,'0'+CR+'LINE');        { Linie }
        WriteLn(DateiHandel,'8'+CR+'1');           { Layer }
        WriteLn(DateiHandel,'62'+CR+Color);        { Farbe }
{        WriteLn(DateiHandel,'5'+CR+'3');  { ?? }

        WriteLn(DateiHandel,'10');
        WriteLn(DateiHandel,Copy(LinieStr,3,Pos(',',LinieStr)-3));
        WriteLn(DateiHandel,'20');
        St100 := Copy(LinieStr,Pos(',',LinieStr)+1,100);
        WriteLn(DateiHandel,Copy(ST100,1,Pos(';',ST100)-1));

        If Copy(Data[Linie+1],1,2)='PA' Then Begin; { Gibts eine Folge Kordinate }
          LinieStr:=Data[Linie+1];
        End Else Begin;
          If (Copy(Data[Linie+1],1,2)='PD') And (Copy(Data[Linie+2],1,2)='PA') Then Begin; { Gibts eine Folge Kordinate }
            Inc(Linie);
            LinieStr:=Data[Linie+1];
        End;

        End;
        WriteLn(DateiHandel,'11');
        WriteLn(DateiHandel,Copy(LinieStr,3,Pos(',',LinieStr)-3));
        WriteLn(DateiHandel,'21');
        St100 := Copy(LinieStr,Pos(',',LinieStr)+1,100);
        WriteLn(DateiHandel,Copy(ST100,1,Pos(';',ST100)-1));
      End;
      Inc(Linie);
    End;
    WriteLn(DateiHandel,'0'+CR+'ENDSEC');
    { Ende DXF File }
    WriteLn(DateiHandel,'0'+CR+'EOF');
    CloseFile(DateiHandel);
End;

{ Save File }
procedure TMakeGL.MenuSpeichernClick(Sender: TObject);
begin
  if OpenDialog.Filename <> '' then
  begin
    SaveData(SaveDialog.FileName);
  end
  else MenuSpeichernUnterClick(Sender);
end;

{ Save File as }
Procedure TMakeGL.MenuSpeichernunterClick(Sender: TObject);
Begin
  With SaveDialog Do
    If Execute Then Begin;
      OpenDialog.FileName := SaveDialog.FileName;
      SaveData(SaveDialog.FileName);
    End;
End;

{ Initialisierung des Programmes }
Procedure TMakeGL.Init(Sender: TObject);
Var IniHandel: TIniFile;
Begin
  Data[0]                := 'ENDE';               { Setze Buffer auf leer }
  MakeGL.Caption         := Titel;
  MakeGL.ClientHeight    := 170;                  { Grsse des Haupt-Fensters }
  MakeGL.ClientWidth     := 330;
  MakeGL.Top             := 50;                   { X,Y Kordinaten des Haupt-Fensters }
  MakeGL.Left            := 50;
  AppPath                := ExtractFilePath(Application.EXEName);           { Wird fr Help- & Ini-File Lokal bentigt }
  IniHandel   := TIniFile.Create(AppPath+AppIni);                           { Ini File ffnen }
  CountMax    := IniHandel.ReadInteger('BMPCONVERT', 'PIXPRODRILL', 30);    { geht mit max150 min10 }
  CountMin    := IniHandel.ReadInteger('BMPCONVERT', 'PIXPRODRILLMIN', 10); { geht mit max60 min10 }
  Raster      := IniHandel.ReadInteger('BMPCONVERT', 'RASTER', 2);          { Abtsten von BMPs fr Bohrungen}
  RasterHor   := IniHandel.ReadInteger('BMPCONVERT', 'RASTERHOR', 6);       { Abtsten von BMPs fr Horizontal Vektorisieren}
  BMPXFAK     := IniHandel.ReadInteger('BMPCONVERT', 'BMPXFAKTOR', 30);     { Fakto X fr BMPs opt = 30}
  BMPYFAK     := IniHandel.ReadInteger('BMPCONVERT', 'BMPYFAKTOR', 30);     { Fakto Y fr BMPs opt = 30}
  WinkelDif   := IniHandel.ReadInteger('BMPCONVERT', 'WinkelDiff', 3);      { Winkelfehler fr Polilinie opt = 3}
  PixProLinie := IniHandel.ReadInteger('BMPCONVERT', 'PIXPROLINIE', 1);     { Anzahl Pixels die eine Frslinie Bilden (Abtasten) Opt=1}
  PixProMM    := IniHandel.ReadInteger('BMPCONVERT', 'PIXPROMM', 4);        { anz Pixels ist ein mm (fr Bohr-Loch) opt=4}
  Mitteilung.Caption :=  IniHandel.ReadString('MAKEHPGL', 'STARTMSG', 'Ini-Datei fehlt'); { INI Meldung ok }
  IniHandel.Free;                                                           { Ini-File lesen abschliessen }
  BuffNutz.Caption := '0 %';                                                { Anzeige Zurck setzen }
End;

{ Image nach Bohr-Lchern durchsuchen }
Procedure TMakeGL.ScanImg;
Var X,Y,XX,YY : LongInt;
    LastBlack : Word;             { Merke ob letztes Pixel Schwarz war viel schneller}
    StrX,StrY : String[10];
    Linie     : LongInt;
    N         : Int64;
    Bohrer    : LongInt;
    BohrerAlt : LongInt;
Begin
  LastBlack := 0;
  Linie     := 0;
  Y         := 0;
  BohrerAlt := 0;
  ImageDispForm.image.Picture.Bitmap.PixelFormat := pf4bit; { konvertiere auf 16-Farben }
  { Fr weitere Scans sperren in Schwarz }
  ImageDispForm.Image.Canvas.Brush.Color := clBlack;
  ImageDispForm.Image.Canvas.Brush.Style := bsSolid;
  Data[Linie] := 'SP1;';                                   { Buffer initialisieren }
  Inc(Linie);
  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DSLeiterplatte 0,0 Montieren;';
  Inc(Linie);
  Data[Linie] := 'WK;';
  Inc(Linie);
  Repeat;
    X       := 0;
    Repeat;
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] and $C0C0C0 <>clBlack) And (LastBlack=1) Then Begin;

        N:=ScanImgCirc(X,Y);                  { Holen EffPos if Exist }
        If (N and $0ffff)>0 Then Begin;       { Is a Drill }
          XX:=N And $0FFFF;                   { X-Kordinate Bohrloch }
          YY:=(N SHR 16) And $0FFFF;          { Y-Kordinate Bohrloch }
          Bohrer := I;                        { Bohrer Durchmesser }
          If   I<5               Then Bohrer:= 5;
          If (I>= 5) And (I<=15) Then Bohrer:= 8;
          If (I>=15) And (I<=30) Then Bohrer:= 15;
          If (I>=30) And (I>=45) Then Bohrer:= 25;
          I:= Round(I/1.3);                      { Grsse anpassen um die lcher zu schlessen }
          ImageDispForm.Image.Canvas.Ellipse(XX-I, YY-I, XX+I, YY+I);

          Str(XX*BMPXFak,StrX); Str(YY*BMPYFak,StrY);
          Data[Linie] := 'PU;';                           { Vektor setzen }
          Inc(Linie);
          Data[Linie] := 'PA'+StrX+','+StrY+';';
          Inc(Linie);
          Data[Linie] := 'PD;';                           { Bohrung durchfhren }
          Inc(Linie);
          Data[Linie] := 'PU;';
          Inc(Linie);
          If (Round(BohrerAlt/PixProMM) <> Round(Bohrer/PixProMM)) Then Begin;  { Wurde Bohrer gewechselt }
            Str(Round(Bohrer/PixProMM),StrX);
            Data[Linie] := 'DS Bitte Bohrer: '+StrX+'mm einlegen';
            Inc(Linie);
            Data[Linie] := 'WK;';
            Inc(Linie);
          End;
          BohrerAlt := Bohrer;                 { Alter Bohrer Merken }
        End;
        LastBlack := 0;
      End Else Begin;
        LastBlack := 1;
      End;
      X := X + Raster;
    Until X>=ImageDispForm.Image.Picture.Width-1;
    Application.ProcessMessages;
    Str(Round(Linie/DataMax*100),StrX);
    BuffNutz.Caption := StrX+' %';
    Str(Round(Y/ImageDispForm.Image.Picture.Height*100),StrX);
    Mitteilung.Caption := 'Suche Bohrungen '+StrX+'%';
    Y := Y + Raster;
  Until (Y>=ImageDispForm.Image.Picture.Height-1) Or (Linie >=DataMax);
  Data[Linie] := 'PU;';                                     { Bohrung abschliessen Buffer }
  Inc(Linie);
  Data[Linie] := 'DS Leiterplatte bohren ist beendet;';
  Inc(Linie);
  Data[Linie] := 'SP0;';
  Inc(Linie);
  Data[Linie] := 'ENDE';
  Str(Round(Linie/DataMax*100),StrX);
  BuffNutz.Caption := StrX+' %';
  Mitteilung.Caption := 'Suche abgeschlossen';
End;

{ Winkel zwichen zwei Kordinaten errechnen Resultat Integer 0-359Grad }
Function TMakeGL.GetAngel(X,Y,XX,YY:LongInt):LongInt;
Begin;
   If Abs(Y-YY)<>0 Then GetAngel:=Round(ArcTan(Abs(X-XX)/Abs(Y-YY))/3.14159265*360) Else
     GetAngel:=500;
End;

{ Wurm: geht allen Grnen zusammenhngenden Pixels nach inkl. Vektor erstellung }
Function TMakeGL.ScanWurm(Xs,Ys,Linie:LongInt):LongInt;
Var StrX,StrY : String;
    XX,YY     : LongInt;
    Ok        : LongInt;
    Winkel    : LongInt;
    Count     : LongInt;
    Start     : Word;
Begin
  XX:=Xs; YY:=Ys;
  Count := 0;
  Winkel := 500;
  Start :=1;
  ImageDispForm.Image.Canvas.Pixels[Xs,Ys]:=clGreen;

  Repeat;
    OK:=0;
    If ImageDispForm.Image.Canvas.Pixels[Xs+1,Ys]=clRed Then Begin;
      Inc(Xs); Inc(OK);
      ImageDispForm.Image.Canvas.Pixels[Xs,Ys]:=clGreen;
    End;
    If ImageDispForm.Image.Canvas.Pixels[Xs,Ys+1]=clRed Then Begin;
      Inc(Ys); Inc(OK);
      ImageDispForm.Image.Canvas.Pixels[Xs,Ys]:=clGreen;
    End;
    If ImageDispForm.Image.Canvas.Pixels[Xs-1,Ys]=clRed Then Begin;
      Dec(Xs); Inc(OK);
      ImageDispForm.Image.Canvas.Pixels[Xs,Ys]:=clGreen;
    End;
    If ImageDispForm.Image.Canvas.Pixels[Xs,Ys-1]=clRed Then Begin;
      Dec(Ys); Inc(OK);
      ImageDispForm.Image.Canvas.Pixels[Xs,Ys]:=clGreen;
    End;
    If ImageDispForm.Image.Canvas.Pixels[Xs+1,Ys+1]=clRed Then Begin;
      Inc(Xs); Inc(Ys); Inc(OK);
      ImageDispForm.Image.Canvas.Pixels[Xs,Ys]:=clGreen;
    End;
    If ImageDispForm.Image.Canvas.Pixels[Xs-1,Ys-1]=clRed Then Begin;
      Dec(Xs); Dec(Ys); Inc(OK);
      ImageDispForm.Image.Canvas.Pixels[Xs,Ys]:=clGreen;
    End;
    If ImageDispForm.Image.Canvas.Pixels[Xs+1,Ys-1]=clRed Then Begin;
      Inc(Xs); Dec(Ys); Inc(OK);
      ImageDispForm.Image.Canvas.Pixels[Xs,Ys]:=clGreen;
    End;
    If ImageDispForm.Image.Canvas.Pixels[Xs-1,Ys+1]=clRed Then Begin;
      Dec(Xs); Inc(Ys); Inc(OK);
      ImageDispForm.Image.Canvas.Pixels[Xs,Ys]:=clGreen;
    End;
    str(count,strx);
    Inc(Count);
    If Count=2 Then Winkel := GetAngel(Xs,Ys,XX,YY);

    If (Start=1) And (OK>0) Then Begin;
      Data[Linie] := 'PU;';                  { HPGL Start Poli-Linie }
      Inc(Linie);
      Str(XX*BMPXFAK,StrX); Str(YY*BMPYFAK,StrY);
      Data[Linie] := 'PA'+StrX+','+StrY+';';
      Inc(Linie);
      Data[Linie] := 'PD;';
      Inc(Linie);
      Start:=3;
    End;

    If (Count > 2) And (Abs(Winkel-GetAngel(Xs,Ys,XX,YY))>WinkelDif) Then Begin;
        Str(Xs*BMPXFAK,StrX); Str(Ys*BMPYFAK,StrY);                { Nchster Poli-Linien Punkt }
        Data[Linie] := 'PA'+StrX+','+StrY+';';
        Inc(Linie);
        XX:=Xs; YY:=Ys;
        Count := 0;
        If Linie Mod 1000 = 0 Then Begin;
          Application.ProcessMessages;
          Str(Round(Linie/DataMax*100),StrX);
          BuffNutz.Caption := StrX+' %';
        End;
    End;
  Until OK=0;
  { Polinom Ende }
  If Start=3 Then Begin;
    Str(Xs*BMPXFak,StrX); Str(Ys*BMPYFAK,StrY);
    Data[Linie] := 'PA'+StrX+','+StrY+';';
    Inc(Linie);
    Data[Linie] := 'PU;';
    Inc(Linie);
  End;
  ScanWurm := Linie;
End;

{ Vektorisieren Out-Line Ganzes Image }
Procedure TMakeGL.ScanOutLine;
Var X,Y       : LongInt;
    Linie     : LongInt;
    Str1      : String[100];
Begin
  Linie     := 0;
  Y         := 0;
  ImageDispForm.image.Picture.Bitmap.PixelFormat := pf4bit; { konvertiere auf 16-Farben }
  Data[Linie] := 'SP1;';
  Inc(Linie);
  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DS Leiterplatte Montieren Referenz 0,0;';
  Inc(Linie);
  Data[Linie] := 'WK;';
  Inc(Linie);

  {Erstelle Rote umrisse um alle Objekte }
  Repeat;
    X       := 2;
    Repeat;
      { Immer von Links an Objekte Fahren und sehen ob sie was sind }
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] and $C0C0C0 = clBlack) And
         (ImageDispForm.Image.Canvas.Pixels[X+1,Y] and $C0C0C0 <> clBlack) Then
         ImageDispForm.Image.Canvas.Pixels[X+1,Y]:=clRed;
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] and $C0C0C0 <> clBlack) And
         (ImageDispForm.Image.Canvas.Pixels[X+1,Y] and $C0C0C0 = clBlack) Then
         ImageDispForm.Image.Canvas.Pixels[X,Y]:=clRed;
      If (ImageDispForm.Image.Canvas.Pixels[X,Y-1] and $C0C0C0 = clBlack) And
         (ImageDispForm.Image.Canvas.Pixels[X,Y] and $C0C0C0 <> clBlack) Then
         ImageDispForm.Image.Canvas.Pixels[X,Y]:=clRed;
      If (ImageDispForm.Image.Canvas.Pixels[X,Y-1] and $C0C0C0 <> clBlack) And
         (ImageDispForm.Image.Canvas.Pixels[X,Y] and $C0C0C0 = clBlack) Then
         ImageDispForm.Image.Canvas.Pixels[X,Y-1]:=clRed;
      Inc(X);
    Until (X>=ImageDispForm.Image.Picture.Width-1);
    Application.ProcessMessages;
    Str(Round(Linie/DataMax*100),Str1);
    BuffNutz.Caption := Str1+' %';
    Str(Round(Y/ImageDispForm.Image.Picture.Height*100),Str1);
    Mitteilung.Caption := 'Umrisse suchen '+Str1+'%';
    Inc(Y);
  Until (Y>=ImageDispForm.Image.Picture.Height-1);

  { Alles Schwarzen Pixels entfernen, so dass nur noch Rote Out-Lines existieren }
  Y         := 0;
  Repeat;
    X       := 2;
    Repeat;
      { Immer von Links an Objekte Fahren und sehen ob sie was sind }
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] and $C0C0C0 = clBlack) Then
         ImageDispForm.Image.Canvas.Pixels[X,Y]:=clWhite;
      Inc(X);
    Until (X>=ImageDispForm.Image.Picture.Width-1);
    Application.ProcessMessages;
    Str(Round(Linie/DataMax*100),Str1);
    BuffNutz.Caption := Str1+' %';
    Str(Round(Y/ImageDispForm.Image.Picture.Height*100),Str1);
    Mitteilung.Caption := 'Objekt entfernen '+Str1+'%';
    Inc(Y);
  Until (Y>=ImageDispForm.Image.Picture.Height-1);


  { Den roten OutLine Linien nachgehen (Wurm) und in Grn Darstellen}
  Y := 0;
  Repeat;
    X := 2;
    Repeat;
      { Immer von Links an Objekte Fahren und sehen ob sie was sind }
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] <> clWhite {clRed}) Then Begin;
         Linie := ScanWurm(X,Y,Linie);
     End;
      Inc(X);
    Until (X>=ImageDispForm.Image.Picture.Width-1) Or (linie >= DataMax);
    Application.ProcessMessages;
    Str(Round(Linie/DataMax*100),Str1);
    BuffNutz.Caption := Str1+' %';
    Str(Round(Y/ImageDispForm.Image.Picture.Height*100),Str1);
    Mitteilung.Caption := 'Vektoren bilden '+Str1+'%';
    Inc(Y);
  Until (Y>=ImageDispForm.Image.Picture.Height-1) Or (Linie >= DataMax);


  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DS Leiterplatte Fraesen ist beendet;';
  Inc(Linie);
  Data[Linie] := 'SP0;';
  Inc(Linie);
  Data[Linie] := 'ENDE';
  Str(Round(Linie/DataMax*100),Str1);
  BuffNutz.Caption := Str1+' %';
  Mitteilung.Caption := 'Vektoren abgeschlossen';
End;

{ HPGL Bild Zeichnen }
Procedure TMakeGL.DrawImg;
Var Linie : LongInt;
    X,Y   : LongInt;
    StrX, StrY : String[20];
    Dummy : Integer;
    PenActive : Word;
Begin
  PenActive := 0;
  Linie := 0;
  ImageDispForm.Image.Canvas.Pen.Color := clBlack;
  StrX:=''; StrY:='';
  While Data[Linie]<>'ENDE' do Begin;
    StrX:=Copy(Data[Linie],3,Pos(',',Data[Linie])-1);
    StrY:=Copy(Data[Linie],Pos(',',Data[Linie])+1,10);
    Val(StrX,X,Dummy); Val(StrY,Y,Dummy);
    X:=Round(({6000+}X)/BMPXFAK);                        { Grsse Anpassen }
    Y:=Round(({5000+}Y)/BMPYFAK);
    If Copy(Data[Linie],1,2)='SP' Then Begin;            { Stift }
      StrX:=Copy(Data[Linie],3,1);
      Val(StrX,X,Dummy);
      Case X of                                          { Stift auswhlen }
        0:ImageDispForm.Image.Canvas.Pen.Color := clBlack;
        1:ImageDispForm.Image.Canvas.Pen.Color := clBlack;
        2:ImageDispForm.Image.Canvas.Pen.Color := clRed;
        3:ImageDispForm.Image.Canvas.Pen.Color := clBlue;
        4:ImageDispForm.Image.Canvas.Pen.Color := clGreen;
        5:ImageDispForm.Image.Canvas.Pen.Color := clYellow;
        6:ImageDispForm.Image.Canvas.Pen.Color := clGray;
      End;
    End;
    If Copy(Data[Linie],1,2)='PU' Then PenActive := 0;    { Stifte nach oben }
    If Copy(Data[Linie],1,2)='PD' Then PenActive := 1;    { Stift unten }
    If Copy(Data[Linie],1,2)='PA' Then Begin;             { Zeichne das zeugs }
      If PenActive = 0 Then ImageDispForm.Image.Canvas.MoveTo(X,Y);
      If PenActive = 1 Then ImageDispForm.Image.Canvas.LineTo(X,Y);
      { Es es ein Bohrloch }
      If (Copy(Data[Linie+1],1,3)='PD;') And (Copy(Data[Linie+2],1,3)='PU;') Then Begin;        { Stifte nach oben }
        ImageDispForm.Image.Canvas.Brush.Color := clRed;
        ImageDispForm.Image.Canvas.Brush.Style := bsSolid;
        ImageDispForm.Image.Canvas.Ellipse(X-5,Y-5,X+5,Y+5); { das muss ein Bohrloch Sein }
      End;
    End;
    Inc(Linie);
    If Linie Mod 1000 = 0 Then Begin;                     { Task wieder mal abgeben }
      Application.ProcessMessages;
      Str(Round(Linie/DataMax*100),StrX);
      BuffNutz.Caption := StrX+' %';
      Str(Round(Y/ImageDispForm.Image.Picture.Height*100),StrX);
      Mitteilung.Caption := 'Vektore Zeichnen '+StrX+'%';
    End;
  End;
  Mitteilung.Caption := 'Zeichnen angeschlossen';
End;

{ Lcher suchen und Durchmesser eruieren }
Function TMakeGL.ScanImgCirc(XX,YY:LongInt):LongInt;
Var Count, Dir, OK      : Word;
    X,Y                 : LongInt;
    XMin,XMax,YMin,YMax : LongInt;
    Bohrer              : LongInt;
Begin;
  Count := 0;
  Dir := 0;
  Repeat;
    OK := 0;

    If (OK=0) And (Dir=0) Then                          { Ist da rechts was }
      If (ImageDispForm.Image.Canvas.Pixels[XX+1,YY] And $C0C0C0 <>clBlack) Then Begin;
        Inc(XX); Dir:=0; OK:=1 End Else Begin;
        If ImageDispForm.Image.Canvas.Pixels[XX,YY+1] And $C0C0C0 <>clBlack Then Begin;
          Inc(YY); Dir:=0; OK:=1 End Else Dir := 1;
      End;

    If (OK=0) And (Dir=1) Then                          { Ist da unten was }
      If (ImageDispForm.Image.Canvas.Pixels[XX,YY+1] And $C0C0C0<>clBlack) Then Begin;
        Inc(YY); Dir:=1; OK:=1 End Else Begin;
        If (ImageDispForm.Image.Canvas.Pixels[XX-1,YY] And $C0C0C0<>clBlack) Then Begin;
          Dec(XX); Dir:=1; OK:=1 End Else Dir := 2;
      End;

    If (OK=0) And (Dir=2) Then                          { Ist da links was }
      If (ImageDispForm.Image.Canvas.Pixels[XX-1,YY] And $C0C0C0 <>clBlack) Then Begin;
        Dec(XX); Dir:=2; OK:=1 End Else Begin;
        If (ImageDispForm.Image.Canvas.Pixels[XX,YY-1] And $C0C0C0 <>clBlack) Then Begin;
          Dec(YY); Dir:=2; OK:=1 End Else Dir := 3;
      End;

    If (OK=0) And (Dir=3) Then                          { Ist da oben was }
      If (ImageDispForm.Image.Canvas.Pixels[XX,YY-1] And $C0C0C0 <>clBlack) Then Begin;
        Dec(YY); Dir:=3; {OK:=1} End Else Begin;
        If (ImageDispForm.Image.Canvas.Pixels[XX+1,YY] And $C0C0C0 <>clBlack) Then Begin;
          Inc(XX); Dir:=3; {OK:=1} End Else Dir := 4;
      End;

    Inc( Count );
  Until ((Count > CountMax) Or (Dir = 4));
  If ((Dir=4) And (Count > CountMin)) Then ScanImgCirc := 1 Else ScanImgCirc := 0;

  { Suchen Nach dem effektiven Mittelpunkt }
  If ((Dir=4) And (Count > CountMin)) Then Begin;

    { Suchen nach X-Mittelpunkt}
    X:=XX;
    While (XX-Round(Count/2)<X) And (ImageDispForm.Image.Canvas.Pixels[X,YY] And $C0C0C0 <> clBlack) Do Begin;
      Dec(X);
    End;
    XMin := X;
    X:=XX;
    While (XX+Round(Count/2)>X) And (ImageDispForm.Image.Canvas.Pixels[X,YY] And $C0C0C0 <> clBlack) Do Begin;
      Inc(X);
    End;
    XMax := X;
    XX := Round((XMax+XMin)/2);        { Neuer Effektiver XX Mittelpunkt Festlegen }

    { Suchen nach Y-Mittelpunkt}
    Y:=YY;
    While (YY-Round(Count/2)<Y) And (ImageDispForm.Image.Canvas.Pixels[XX,Y] And $C0C0C0 <> clBlack) Do Begin;
      Dec(Y);
    End;
    YMin := Y;
    Y:=YY;
    While (YY+Round(Count/2)>Y) And (ImageDispForm.Image.Canvas.Pixels[XX,Y] And $C0C0C0 <> clBlack) Do Begin;
      Inc(Y);
    End;
    YMax := Y;
    YY := Round((YMax+YMin)/2);        { Neuer Effektiver YY Mittelpunkt Festlegen }
    ScanImgCirc := XX + (YY Shl 16);   { Zurck mit den effektiven kordinaten }

    { Bohr Durchmesser suchen }
    If Abs(XMax-XMin) > Abs(YMax-YMin) Then Bohrer:=Abs(XMax-XMin) Else Bohrer:=Abs(YMax-YMin);
    I:=Bohrer;                         { Zurck mit dem Bohrer Durchmesser }
  End;
End;

{ Bild (Image) zum Drucken vorbereiten }
Procedure TMakeGL.MenuDruckenClick(Sender: TObject);
Var  X,Y : LongInt;
     Str1 : String;
Begin;
  If PrintDialog.Execute Then Begin;
    Printer.BeginDoc;                          { Drucker BitMap ffnen }
    { Konvertiere Bit Map auf Printer }
    Y         := 0;
    ImageDispForm.Image.Canvas.Pen.Color:=clBlack;
    Canvas.Brush.Style := bsSolid;
    Repeat;
      X       := 0;
      Repeat;
        { Nur bei Farbe abbilden }
        If ImageDispForm.Image.Canvas.Pixels[X,Y]<>clWhite Then Begin;
          Canvas.Brush.Color := ImageDispForm.Image.Canvas.Pixels[X,Y];
          Printer.Canvas.Ellipse(X*PrtFak, Y*PrtFak, X*PrtFak+PrtFak, Y*PrtFak+PrtFak);
{          Printer.Canvas.Pixels[X*PrtFak, Y*PrtFak] := ImageDispForm.Image.Canvas.Pixels[X,Y];}
        End;
        Inc(X);
      Until X>=ImageDispForm.Image.Picture.Width-1;
      Application.ProcessMessages;
      Str(Round(Y/(ImageDispForm.Image.Picture.Height-1)*100),Str1);
      Mitteilung.Caption := 'Drucke: '+Str1+' % erledigt';
      Inc(Y);
    Until (Y>=ImageDispForm.Image.Picture.Height-1);
{    Printer.Canvas.Rectangle(100,100,1100,1100);}
    Printer.EndDoc;                               { Druck starten }
  End;
End;

Procedure TMakeGL.MenuVorschauClick(Sender: TObject);
Begin
  If MenuVorschau.Checked = False Then Begin;
    MenuVorschau.Checked := True;
    ImageDispForm.Top := MakeGL.Top;
    ImageDispForm.Left := MakeGL.Left + MakeGL.Width + 10;
    ImageDispForm.Show;
    ImageDispForm.Visible := True;
    ImageDispForm.FormStyle := fsNormal;
    ImageDispForm.Caption := Titel + ' - [namenlos]';
    If Length(ExtractFilename(OpenDialog.FileName))>2 Then
      ImageDispForm.Caption := Titel + ' - '+ ExtractFilename(OpenDialog.FileName)
    Else
      ImageDispForm.Caption := Titel + ' - [namenlos]';
    ImageDispForm.Image.RePaint;
  End Else Begin;
    MenuVorschau.Checked := False;
    ImageDispForm.Visible := False;
  End;

End;

Procedure TMakeGL.MenuHilfeThemenClick(Sender: TObject);
Begin
  Application.HelpFile := AppPath+'MakeHPGL.hlp';         {HelpFile}
  Application.HelpCommand(HELP_CONTENTS, 0);
End;

Procedure TMakeGL.MenuKopierenClick(Sender: TObject);
Begin
  Mitteilung.Caption := 'Zwischenablage gefllt';
  Clipboard.Assign(ImageDispForm.Image.Picture);
End;

Procedure TMakeGL.MenuEinfgenClick(Sender: TObject);
Var I,OK :Word;
Begin
  { Testen ob Clipboard innhalt OK }
  OK := 0;
  For I := 0 To Clipboard.FormatCount-1 do Begin;
    If (Clipboard.Formats[I]=CF_BITMAP)  Then OK:=1;      { BMP 16 Farben }
    If (Clipboard.Formats[I]=CF_PICTURE) Then OK:=1;      { Kein Canvas Objekt Bild }
  End;
  Case OK Of
    0:Mitteilung.Caption := 'Zwischenablage war leer';
    1:Begin;
        Mitteilung.Caption := 'Zwischenablage eingefgt';
        ImageDispForm.Image.Picture.Assign(Clipboard);
{        ImageDispForm.image.Picture.Bitmap.PixelFormat := pf4bit; { konvertiere auf 16-Farben }
      End;
    2:Mitteilung.Caption := 'Bild nicht 16-Farb BMP';
  End;
  If ImageDispForm.Image.Picture.BitMap.Height < 10 Then
    Mitteilung.Caption := 'Bild nicht 16-Farb BMP';
End;

{ Kommunikation Unidirektional COM1.. Vektoren im HPGL bermitteln }
Procedure TMakeGL.MenuUbermittelnCNCClick(Sender: TObject);
Var Linie     : LongInt;
    COMConf   : TCommConfig;
    hCOM      : THandle;
    COMHandel : TextFile;
    IniHandel : TIniFile;
    Str1      : String[20];
Begin
  Mitteilung.Caption := 'bermittlung luft';
  COMConf.dwSize := SizeOf(COMConf);
  GetDefaultCommConfig('COM1',COMConf, COMConf.dwSize);
  hCOM := 0;                                     { Damit der Compiler nicht Motzt }
  GetCommState(hCOM, COMConf.DCB);
  IniHandel := TIniFile.Create(AppPath+AppIni);  { Hole die Parameter aus der Ini }
  COMConf.DCB.DCBlength := SizeOf(COMConf.DCB);  { Strucktur grssen ist erster eintrag }
  COMConf.DCB.BaudRate := IniHandel.ReadInteger('COMCNC', 'BAUD', 9600);
  COMConf.DCB.ByteSize := IniHandel.ReadInteger('COMCNC', 'BITS', 8);
  COMConf.DCB.Parity := 0;
  COMConf.DCB.StopBits := 1;
  IniHandel.Free;                                { Ini File Schlissen }
  SetCommState(hCOM, COMConf.DCB);               { Setze COM parameter }
  Linie := 0;
  AssignFile(COMHandel,'COM1'{+IniHandel.ReadString('COMCNC', 'COM', '1')});
  ReWrite(COMHandel);
  While (Data[Linie]<>'ENDE') do Begin           { Buffer senden }
    WriteLn(COMHandel,Data[Linie]);
    Inc(Linie);
    If Linie Mod 500 = 0 Then Begin;                       { Alle 1000 Zeilen Windows frei geben }
      Application.ProcessMessages;
      Str(Round(Linie/DataMax*100),Str1);
      Mitteilung.Caption := 'Block: '+Str1+' ';
    End;
  End;
  CloseFile(COMHandel);                          { Schnittstellen COM schliessen }
  Mitteilung.Caption := 'bermittlung abgeschlosen';
End;

{ Bild Abtasten wagerechte Vektoren reinlegen (Dunkle Stellen) }
Procedure TMakeGL.BMPAbtasten;
Var X,Y       : LongInt;
    StrX,StrY : String[10];
    Linie     : LongInt;
Begin
  Linie     := 0;
  Y         := 0;
  Data[Linie] := 'SP1;';
  Inc(Linie);
  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DSBitte Fraesteil 0,0 montieren;';
  Inc(Linie);
  Data[Linie] := 'WK;';
  Inc(Linie);
  ImageDispForm.Image.Canvas.Pen.Color:=clRed;
  Repeat;
    X       := 0;
    Repeat;
      If ((ImageDispForm.Image.Canvas.Pixels[X,Y] =clWhite) Or (X=0)) And
         (ImageDispForm.Image.Canvas.Pixels[X+1,Y] <> clWhite) Then Begin;
          Str(X*BMPXFak,StrX); Str(Y*BMPYFak,StrY);
          Data[Linie] := 'PU;';
          Inc(Linie);
          Data[Linie] := 'PA'+StrX+','+StrY+';';
          Inc(Linie);
          ImageDispForm.Image.Canvas.MoveTo(X+1,Y);
          Repeat;
            Inc(X);
          Until (ImageDispForm.Image.Canvas.Pixels[X,Y] <> clWhite) And
                (ImageDispForm.Image.Canvas.Pixels[X+1,Y] = clWhite) Or
                (X>=ImageDispForm.Image.Picture.Width-1);
          ImageDispForm.Image.Canvas.LineTo(X+1,Y);
          Str(X*BMPXFak,StrX); Str(Y*BMPYFak,StrY);
          Data[Linie] := 'PD;';
          Inc(Linie);
          Data[Linie] := 'PA'+StrX+','+StrY+';';
          Inc(Linie);
      End;
      Inc(X);
    Until X>=ImageDispForm.Image.Picture.Width;
    Y := Y + PixProLinie;
    Application.ProcessMessages;
    Str(Round(Linie/DataMax*100),StrX);
    BuffNutz.Caption := StrX+' %';
    Str(Round(Y/(ImageDispForm.Image.Picture.Height)*100),StrX);
    Mitteilung.Caption := 'Abtasten '+StrX+' % erledigt';
  Until (Y>=ImageDispForm.Image.Picture.Height) Or (Linie >=DataMax);
  Mitteilung.Caption := 'Abtasten beendet';

  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DSFraesteil bearbeitung ist beendet;';
  Inc(Linie);
  Data[Linie] := 'SP0;';
  Inc(Linie);
  Data[Linie] := 'ENDE';
  Str(Round(Linie/DataMax*100),StrX);
  BuffNutz.Caption := StrX+' %';
End;

{ Bild Abtasten wagerechte Vektoren reinlegen (Helle Stellen) }
Procedure TMakeGL.BMPAbtastNeg;
Var X,Y       : LongInt;
    StrX,StrY : String[10];
    Linie     : LongInt;
Begin
  Linie     := 0;
  Y         := 0;
  Data[Linie] := 'SP1;';
  Inc(Linie);
  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DSBitte Fraesteil 0,0 montieren;';
  Inc(Linie);
  Data[Linie] := 'WK;';
  Inc(Linie);
  ImageDispForm.Image.Canvas.Pen.Color:=clRed;
  Repeat;
    X       := 0;
    Repeat;
      If (X=0) Or (ImageDispForm.Image.Canvas.Pixels[X,Y] = clWhite) Then Begin;
        Data[Linie] := 'PU;';
        Inc(Linie);
        Str(X*BMPXFak,StrX); Str(Y*BMPYFak,StrY);
        Data[Linie] := 'PA'+StrX+','+StrY+';';
        Inc(Linie);
        ImageDispForm.Image.Canvas.MoveTo(X,Y);
        Repeat;
          Inc(X);
        Until (ImageDispForm.Image.Canvas.Pixels[X,Y] <> clWhite) Or
              (X>=ImageDispForm.Image.Picture.Width);
        ImageDispForm.Image.Canvas.LineTo(X,Y);
        Data[Linie] := 'PD;';
        Inc(Linie);
        Str(X*BMPXFak,StrX); Str(Y*BMPYFak,StrY);
        Data[Linie] := 'PA'+StrX+','+StrY+';';
        Inc(Linie);
      End;
      If X>=ImageDispForm.Image.Picture.Width-1 Then Begin; { Am rechten Rand beenden }
        ImageDispForm.Image.Canvas.LineTo(X,Y);
        Data[Linie] := 'PD;';
        Inc(Linie);
        Str(X*BMPXFak,StrX); Str(Y*BMPYFak,StrY);
        Data[Linie] := 'PA'+StrX+','+StrY+';';
        Inc(Linie);
      End;
      Inc(X);
    Until X>=ImageDispForm.Image.Picture.Width;
    Y := Y + PixProLinie;
    Application.ProcessMessages;
    Str(Round(Linie/DataMax*100),StrX);
    BuffNutz.Caption := StrX+' %';
    Str(Round(Y/(ImageDispForm.Image.Picture.Height-1)*100),StrX);
    Mitteilung.Caption := 'Abtasten '+StrX+' % erledigt';
  Until (Y>=ImageDispForm.Image.Picture.Height) Or (Linie >=DataMax);
  Mitteilung.Caption := 'abtasten beendet';

  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DSFraesteil bearbeitung ist beendet;';
  Inc(Linie);
  Data[Linie] := 'SP0;';
  Inc(Linie);
  Data[Linie] := 'ENDE';
  Str(Round(Linie/DataMax*100),StrX);
  BuffNutz.Caption := StrX+' %';
End;

{ Konvertiere Image auf Schwarz/(Weiss) alles was <> weiss ist wird schwarz }
Procedure TMakeGL.MakeMono;
Var X,Y       : LongInt;
    Linie     : LongInt;
    Str1      : String[10];
Begin
  Linie     := 0;
  {Konvertieren HPGL zu Schwarz (Weiss)}
  Repeat;
    If Copy(Data[Linie],1,2) = 'SP' Then Begin;
      Data[Linie] := 'SP1;';         { Alles auf Schwarz }
    End;
    Inc(Linie);
  Until (Data[Linie]='ENDE') Or (Data[Linie-1]='ENDE') Or (Linie>=DataMax);
  DrawImg;                           { Zeichne HPGL Buffer Neu }

  { Konvertiere Bit Map auf S/W }
  Y         := 0;
  ImageDispForm.Image.Canvas.Pen.Color:=clBlack;
  Repeat;
    X       := 0;
    Repeat;
      { Farben Adieren nur Luma ohne Chroma ohne Chroma korrektur wegen revers konversion }
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] And $FF +
         (ImageDispForm.Image.Canvas.Pixels[X,Y] And $FF00) Shr 8 +
         (ImageDispForm.Image.Canvas.Pixels[X,Y] And $FF0000) Shr 16) < 3*128 Then
        ImageDispForm.Image.Canvas.Pixels[X,Y]:=clBlack
      Else
        ImageDispForm.Image.Canvas.Pixels[X,Y]:=clWhite;
      Inc(X);
    Until X>=ImageDispForm.Image.Picture.Width;
    Application.ProcessMessages;
    Str(Round(Linie/DataMax*100),Str1);
    BuffNutz.Caption := Str1+' %';
    Str(Round(Y/(ImageDispForm.Image.Picture.Height-1)*100),Str1);
    Mitteilung.Caption := 's/w '+Str1+' % erledigt';
    Inc(Y);
  Until (Y>=ImageDispForm.Image.Picture.Height) Or (Linie >=DataMax);
  Mitteilung.Caption := 'konvertieren beendet';
End;

{ Spiegle Image }
Procedure TMakeGL.BMPSpiegeln;
Var X,Y       : LongInt;
    Xi,Yi     : LongInt;
    Pixel     : LongInt;
    Str1      : String[10];
Begin
  { Spiegeln Bit Map }
  Xi := ImageDispForm.Image.Picture.BitMap.Width;
  Yi := ImageDispForm.Image.Picture.BitMap.Height;
  If Xi>Yi Then ImageDispForm.Image.Picture.BitMap.Height := Xi  { mache das Ding rechteckig }
    Else ImageDispForm.Image.Picture.BitMap.Width := Yi;
  ImageDispForm.Image.Picture.BitMap.Canvas.ReFresh;
  Y         := 1;
  Repeat;
    X       := 0;
    Repeat;
      Pixel := ImageDispForm.Image.Canvas.Pixels[X,Y];{ImageDispForm.Image.Canvas.Pixels[X,Y]}
      ImageDispForm.Image.Canvas.Pixels[X,Y]:=ImageDispForm.Image.Canvas.Pixels[Y,X];
      ImageDispForm.Image.Canvas.Pixels[Y,X]:=Pixel;
      Inc(X);
    Until ArcTan(X/Y)>=Pi/4; { ArcTan(1) = 45Grad Dec - an der 45 Grad Achse spiegeln }
    Application.ProcessMessages;
    Str(Round(Y/(ImageDispForm.Image.Picture.Height-1)*100),Str1);
    Mitteilung.Caption := 'spiegeln '+Str1+' % erledigt';
    Inc(Y);
  Until (Y>=ImageDispForm.Image.Picture.Height);
  ImageDispForm.Image.Picture.BitMap.Height := Xi;  { dem Ding X und Y tauschen }
  ImageDispForm.Image.Picture.BitMap.Width := Yi;
  ImageDispForm.Image.Picture.BitMap.Canvas.ReFresh;
  Mitteilung.Caption := 'konvertieren beendet';
End;

{ Skaliere Image }
Procedure TMakeGL.BMPScale;
Const TimeOut = 300;                       { TimeOut fr Positionieren in 200mS }
Var Str1      : String[10];
    Count     : LongInt;                   { Ablauf Zhler TimeOut }
    MausPosP1 : TPoint;                    { Maus Position auf der Grafik P1 }
    VektorDist : LongInt;                  { Distanz als Vektor }

Begin
  { Skalieren Bit Map }
  MausPos.X := 0;                            { Lsche Alte Position }
  Mitteilung.Caption := 'Skalierung Punkt1 100mm anklicken';
  Count := 0;                                { Setze Time Out Counter fr P1 }
  Repeat;
    Application.ProcessMessages;
    Sleep(200);
  Until (MausPos.X > 0) Or (Count >300);
  MausPosP1 := MausPos;                      { Punkt eins retten }

  Mitteilung.Caption := 'Skalierung Punkt2 100mm anklicken';
  Count := 0;                                { Setze Time Out Counter fr P2 }
  MausPos.Y := 0;                            { Lsche Alte Position }
  Repeat;
    Application.ProcessMessages;
    Sleep(200);
  Until (MausPos.Y > 0) Or (Count >TimeOut);
  { Distanz ausrechnen }
  VektorDist := Round(Sqrt(Sqr(Abs(MausPosP1.X-MausPos.X)) + Sqr(Abs(MausPosP1.Y-MausPos.Y))));
  BMPXFAK := Round(Skalier100mm/VektorDist);      { Fakto X fr BMPs opt = 30}
  BMPYFAK := Round(Skalier100mm/VektorDist);      { Fakto Y fr BMPs opt = 30}
  Str(BMPXFAK,Str1);
  Mitteilung.Caption := 'Skalierung:'+Str1;
End;

Procedure TMakeGL.MenuBMPBohrsuchenClick(Sender: TObject);
Begin
  ScanImg;
End;

Procedure TMakeGL.MenuBMPOutLineVektClick(Sender: TObject);
Begin
  ScanOutLine;
End;

Procedure TMakeGL.MenuabtastenClick(Sender: TObject);
Begin
  BMPAbtasten;
End;

Procedure TMakeGL.MenuabtastennegClick(Sender: TObject);
Begin
  BMPAbtastNeg;
End;

Procedure TMakeGL.MenuToMonoClick(Sender: TObject);
Begin
  MakeMono;
End;

Procedure TMakeGL.MenuSpiegelnClick(Sender: TObject);
Begin
  BMPSpiegeln;
End;

Procedure TMakeGL.MenuSkalierClick(Sender: TObject);
Begin
  BMPScale;
End;

procedure TMakeGL.MenuGrauWertClick(Sender: TObject);
Var X,Y       : LongInt;
    StrX,StrY : String[10];
    Linie     : LongInt;
    Col       : Int64;
    LastWasPoint: LongInt;
    I         : LongInt;
Begin
  Linie     := 0;
  Y         := 0;
  LastWasPoint := 1;                  { Merker fr letzter Punkt }
  Data[Linie] := 'SP1;';
  Inc(Linie);
  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DSBitte Fraesteil 0,0 montieren;';
  Inc(Linie);
  Data[Linie] := 'WK;';
  Inc(Linie);
  Data[Linie] := 'PA0,0;';
  Inc(Linie);
  Data[Linie] := 'PD;';
  Inc(Linie);
  ImageDispForm.Image.Canvas.Pen.Color:=clRed;
  Repeat;
    X       := 0;
    ImageDispForm.Image.Canvas.MoveTo(X,Y);               { Zeile beginn }
    Repeat;
      I := 0;
      Col := 0;                                           { Durchschnitt der Punkte Rechnen }
      Repeat;
        { Farben Adieren nur Luma ohne Chroma ohne Chroma korrektur wegen revers konversion }
        Col := Col + ImageDispForm.Image.Canvas.Pixels[X+I,Y+I] And $FF +
                     (ImageDispForm.Image.Canvas.Pixels[X+I,Y+I] And $FF00) Shr 8 +
                     (ImageDispForm.Image.Canvas.Pixels[X+I,Y+I] And $FF0000) Shr 16;
        Inc(I);
      Until I=RasterHor;
      Col := 255 - Round(Col/3/ RasterHor);                { Durchschnitt der Farbe Rechnen 0-255 }

      If LastWasPoint=1 Then Begin;
        Str(X*BMPXFAK,StrX); Str(Y*BMPYFAK,StrY);          { effektiver Punkt }
        Data[Linie] := 'PA'+StrX+','+StrY+';';
        Inc(Linie);
        ImageDispForm.Image.Canvas.LineTo(X,Y);
      End;

      If (Round(RasterHor/255*Col)>0) Or (X=0) Or           { Ist es ein Punkt <> weiss }
         (X+1>=ImageDispForm.Image.Picture.Width+RasterHor) Then Begin;
        Str(X*BMPXFAK,StrX); Str(Y*BMPYFAK,StrY);           { effektiver Punkt }
        Data[Linie] := 'PA'+StrX+','+StrY+';';
        Inc(Linie);
        ImageDispForm.Image.Canvas.LineTo(X,Y);

        Str((X+(RasterHor shr 1))*BMPXFAK,StrX);            { Virtueller Punkt }
        Str((Y+Round(RasterHor/255*Col))*BMPYFAK,StrY);
        Data[Linie] := 'PA'+StrX+','+StrY+';';
        Inc(Linie);
        ImageDispForm.Image.Canvas.LineTo(X+(RasterHor shr 1),Y+Round(RasterHor/255*Col));
        LastWasPoint:=1;                                    { Merker fr letzter Punkt }
      End Else Begin;
        LastWasPoint:=0;                                    { Merker fr letzter Punkt }
      End;

      If X=0 Then Begin;                                   { Beim ersten Punkt Runter }
        Data[Linie] := 'PD;';
        Inc(Linie);
        ImageDispForm.Image.Canvas.LineTo(X,Y);
      End;

      X := X + RasterHor;
    Until X>=ImageDispForm.Image.Picture.Width+RasterHor;
    ImageDispForm.Image.Canvas.LineTo(X-RasterHor,Y);
    Str((X-RasterHor)*BMPXFAK,StrX); Str(Y*BMPYFAK,StrY);          { Ende des Raster Punkt }
    Data[Linie] := 'PA'+StrX+','+StrY+';';
    Inc(Linie);
    Data[Linie] := 'PU;';
    Inc(Linie);
    Y := Y + RasterHor;
    Application.ProcessMessages;
    Str(Round(Linie/DataMax*100),StrX);
    BuffNutz.Caption := StrX+' %';
    Str(Round(Y/(ImageDispForm.Image.Picture.Height-1)*100),StrX);
    Mitteilung.Caption := 'Grau vekt. '+StrX+' % erledigt';
  Until (Y>=ImageDispForm.Image.Picture.Height+RasterHor) Or (Linie >=DataMax);
  Mitteilung.Caption := 'Bild Grauwerte vektor beendet';

  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DSBild Fraesen ist beendet;';
  Inc(Linie);
  Data[Linie] := 'SP0;';
  Inc(Linie);
  Data[Linie] := 'ENDE';
  Str(Round(Linie/DataMax*100),StrX);
  BuffNutz.Caption := StrX+' %';
End;

{ Bild Farben invertieren }
procedure TMakeGL.MenuInvertClick(Sender: TObject);
Var X,Y       : LongInt;
    Pixel     : Int64;                      { LongInt ergibt Compiler Warnung, wegen -1 Bit abmaskierung }
    Str1      : String[10];
Begin
  Y         := 0;
  Repeat;
    X       := 0;
    Repeat;
      { RGB Farb inversion rechnen }
      Pixel := ImageDispForm.Image.Canvas.Pixels[X,Y];
      Pixel := Pixel And $ffffff00 + ($0000ff - Pixel And $000000ff);    { Rgb }
      Pixel := Pixel And $ffff00ff + ($00ff00 - Pixel And $0000ff00);    { rGb }
      Pixel := Pixel And $ff00ffff + ($ff0000 - Pixel And $00ff0000);    { rgB }
      ImageDispForm.Image.Canvas.Pixels[X,Y]:=Pixel;
      Inc(X);
    Until (X>=ImageDispForm.Image.Picture.Width);
    Application.ProcessMessages;
    Str(Round(Y/(ImageDispForm.Image.Picture.Height-1)*100),Str1);
    Mitteilung.Caption := 'Color invert. '+Str1+' % erledigt';
    Inc(Y);
  Until (Y>=ImageDispForm.Image.Picture.Height);
  ImageDispForm.Image.Picture.BitMap.Canvas.ReFresh;
  Mitteilung.Caption := 'konvertieren beendet';
end;

{ Konturen gltten }
Procedure TMakeGL.MenuGlatenClick(Sender: TObject);
Var X,Y       : LongInt;
    Str1      : String[10];
Begin
  Y         := 0;
  Repeat;
    X       := 0;
    Repeat; { immer 2 Pixel mssen stimmen, es gibt total vier mglichkeiten }
      { Schwarze Punkt einsetzen }
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] and $ff < 128) And
         (ImageDispForm.Image.Canvas.Pixels[X+2,Y] and $ff < 128) Then
        ImageDispForm.Image.Canvas.Pixels[X+1,Y] := clBlack;
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] and $ff < 128) And
         (ImageDispForm.Image.Canvas.Pixels[X,Y+2] and $ff < 128) Then
        ImageDispForm.Image.Canvas.Pixels[X,Y+1] := clBlack;

      { Weisse Punkt einsetzen }
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] and $ff > 128) And
         (ImageDispForm.Image.Canvas.Pixels[X+2,Y] and $ff > 128) Then
        ImageDispForm.Image.Canvas.Pixels[X+1,Y] := clWhite;
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] and $ff > 128) And
         (ImageDispForm.Image.Canvas.Pixels[X,Y+2] and $ff > 128) Then
        ImageDispForm.Image.Canvas.Pixels[X,Y+1] := clWhite;
      Inc(X);
    Until (X>=ImageDispForm.Image.Picture.Width-1);
    Application.ProcessMessages;
    Str(Round(Y/(ImageDispForm.Image.Picture.Height-1)*100),Str1);
    Mitteilung.Caption := 'Konturen gltten '+Str1+' %';
    Inc(Y);
  Until (Y>=ImageDispForm.Image.Picture.Height-1);
  ImageDispForm.Image.Picture.BitMap.Canvas.ReFresh;
  Mitteilung.Caption := 'konturen sind ok';
End;

Procedure TMakeGL.MenuBMPInLineVektClick(Sender: TObject);
Const MaxBreiteStat = 35;
Var X,Y        : LongInt;
    Breite     : LongInt;
    BreiteStat : Array[0..MaxBreiteStat] of LongInt;   { Statistik Array }
    StrX       : String[10];
    Linie      : LongInt;
Begin
  Linie     := 0;
  Y         := 0;
  Data[Linie] := 'SP1;';
  Inc(Linie);
  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DSBitte Fraesteil 0,0 montieren;';
  Inc(Linie);
  Data[Linie] := 'WK;';
  Inc(Linie);
  ImageDispForm.Image.Canvas.Pen.Color:=clRed;
  Breite := 0;               { Festgestellte Linienbreite }
  { Statistik Array lschen}
  For X := 0 To MaxBreiteStat Do
    BreiteStat[X] := 0;
  { Bild Abtasten }
  Repeat;
    X       := 0;
    Repeat;
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] <>clWhite) Then Begin;
        Inc( Breite );
      End Else Begin;
        If (Breite > 0) And (Breite<=MaxBreiteStat) Then Begin;
          Inc(BreiteStat[Breite])
        End;
        Breite := 0;
      End;
      Inc(X);
    Until X>=ImageDispForm.Image.Picture.Width;
    Y := Y + PixProLinie;
    Application.ProcessMessages;
    Str(Round(Linie/DataMax*100),StrX);
    BuffNutz.Caption := StrX+' %';
    Str(Round(Y/(ImageDispForm.Image.Picture.Height)*100),StrX);
    Mitteilung.Caption := 'Linienbreite '+StrX+' % erledigt';
  Until (Y>=ImageDispForm.Image.Picture.Height) Or (Linie >=DataMax);

  { Maximum der Statistik errechnen }
  Breite := 0;
  Y := 0;
  For X := 0 To MaxBreiteStat Do Begin; { Maximale Breite Merken }
    If BreiteStat[X]>Y Then Begin;
      Y := BreiteStat[X];
      Breite := X;
    End;
  End;
  Str(Breite,StrX);
  Mitteilung.Caption := 'Linienbreite '+StrX+' Punkte';
  If Breite > 9 Then ShowMessage('Durchschnittliche Linienbreite zu gross: '+StrX+' Punkte');

  { Markieren Linien Mittelpunkt }
  ImageDispForm.image.Picture.Bitmap.PixelFormat := pf4bit; { konvertiere auf 16-Farben }
  { Fr weitere Scans sperren in Schwarz }
  Y := 0;
  Repeat;
    X       := 0;
    Repeat;
      { Wagerechte }
      If (Breite>0) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-1,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X+1,Y] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>0) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-1,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X+1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+2,Y] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>1) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-2,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X+1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+2,Y] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>2) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-2,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X+1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+3,Y] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>3) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-3,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X+1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+3,Y] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>4) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-3,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-4,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X+1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+3,Y] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>5) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-3,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-4,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X+1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+3,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+4,Y] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>6) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-3,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-4,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X-5,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X+1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+3,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+4,Y] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>7) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-3,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X-4,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X-5,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X+1,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+2,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+3,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X+4,Y] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X+5,Y] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      { Senkrechte }
      If (Breite>0) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-1] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+1] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>0) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-1] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+2] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>1) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-2] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+2] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>2) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-2] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+3] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>3) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-3] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+3] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>4) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-3] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-4] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+3] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>5) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-3] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-4] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+3] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+4] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>6) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-3] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-4] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-5] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+3] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+4] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      If (Breite>7) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-3] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-4] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y-5] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+1] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+2] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+3] = clBlack) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+4] = clWhite) And
          (ImageDispForm.Image.Canvas.Pixels[X,Y+5] = clWhite) Then Begin;
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clRed;
      End;
      Inc(X);
    Until X>=ImageDispForm.Image.Picture.Width;
    Inc(Y);
    Application.ProcessMessages;
    Str(Round(Y/(ImageDispForm.Image.Picture.Height)*100),StrX);
    Mitteilung.Caption := 'Breite reduz. '+StrX+' % erledigt';
  Until Y>=ImageDispForm.Image.Picture.Height;
  Mitteilung.Caption := 'Breite reduzieren beendet';

  { Schwarz entfernen }
  Y := 0;
  Repeat;
    X       := 0;
    Repeat;
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] = clBlack) Then
        ImageDispForm.Image.Canvas.Pixels[X,Y]:= clWhite;
      Inc(X);
    Until X>=ImageDispForm.Image.Picture.Width;
    Inc(Y);
    Application.ProcessMessages;
    Str(Round(Y/(ImageDispForm.Image.Picture.Height)*100),StrX);
    Mitteilung.Caption := 'Schwarz entfernen '+StrX+' % erledigt';
  Until Y>=ImageDispForm.Image.Picture.Height;
  Mitteilung.Caption := 'Schwarz entfernen beendet';


  { Linien zu den Punkten Bilden }
  { Den roten OutLine Linien nachgehen (Wurm) und in Grn Darstellen}
  Y := 0;
  Repeat;
    X := 2;
    Repeat;
      { Immer von Links an Objekte Fahren und sehen ob sie was sind }
      If (ImageDispForm.Image.Canvas.Pixels[X,Y] <> clWhite {clRed}) Then Begin;
         Linie := ScanWurm(X,Y,Linie);
     End;
      Inc(X);
    Until (X>=ImageDispForm.Image.Picture.Width-1) Or (linie >= DataMax);
    Application.ProcessMessages;
    Str(Round(Linie/DataMax*100),StrX);
    BuffNutz.Caption := StrX+' %';
    Str(Round(Y/ImageDispForm.Image.Picture.Height*100),StrX);
    Mitteilung.Caption := 'Vektoren bilden '+StrX+'%';
    Inc(Y);
  Until (Y>=ImageDispForm.Image.Picture.Height-1) Or (Linie >= DataMax);

  Data[Linie] := 'PU;';
  Inc(Linie);
  Data[Linie] := 'DSFraesteil bearbeitung ist beendet;';
  Inc(Linie);
  Data[Linie] := 'SP0;';
  Inc(Linie);
  Data[Linie] := 'ENDE';
  Str(Round(Linie/DataMax*100),StrX);
  BuffNutz.Caption := StrX+' %';
End;

Function TMakeGL.VektorDistanz(StrHPGLVon,StrHPGLBis:String):LongInt;
Var St100 : String[100];
    X,Y,X1,Y1 : LongInt;
    iErr1,iErr2,iErr3,iErr4      : Integer;
Begin;
  Val(Copy(StrHPGLVon,3,Pos(',',StrHPGLVon)-3),X,iErr1);
  St100:=Copy(StrHPGLVon,Pos(',',StrHPGLVon)+1,100);
  Val(Copy(St100,1,Pos(';',St100)-1),Y,iErr2);
  Val(Copy(StrHPGLBis,3,Pos(',',StrHPGLBis)-3),X1,iErr3);
  St100:=Copy(StrHPGLBis,Pos(',',StrHPGLBis)+1,100);
  Val(Copy(St100,1,Pos(';',St100)-1),Y1,iErr4);
  If iErr1+iErr2+iErr3+iErr4 = 0 Then
    VektorDistanz:=Round( Sqrt( Sqr(Abs(Abs(X)-Abs(X1))) + Sqr(Abs(Abs(Y)-Abs(Y1))) ) )
  Else
    VektorDistanz:=0;
End;

Procedure TMakeGL.MenuWegOptClick(Sender: TObject);
Var Linie       : LongInt;
    DataLast    : String[40];
    DateiHandel : TextFile;
    SummeVectD  : LongInt;
    SummeVectU  : LongInt;
    SummeVectN  : LongInt;
    DistanzVect : LongInt;
    DistanzVectPos : LongInt;
    LinieAktiv  : Integer;
    LinieStr    : String[40];
Begin
  Linie       := 0;
  DataLast    := 'PA0,0;';                         { Optimierung starten ab }
  SummeVectD  := 1;                                { 1 wegen division am ende }
  SummeVectU  := 1;
  SummeVectN  := 1;
  LinieAktiv  := 0;                                { Up=0 oder Down=1 ?? }
  If Data[Linie]='ENDE' Then ShowMessage('Es sind noch keine Vektoren generiert worden');
  { Vektoren sumieren }
  While (Data[Linie]<>'ENDE') And (Data[Abs(Linie-1)]<>'ENDE') And (Linie<=DataMax) Do Begin;
    If copy(Data[Abs(Linie-1)],1,2)='PA' Then  LinieAktiv := 1;
    While (copy(Data[Linie],1,2)<>'PA') And (Data[Linie]<>'ENDE') And (Linie<=DataMax) Do Begin;
      Inc(Linie);
      If copy(Data[Abs(Linie-1)],1,2)='PD' Then  LinieAktiv := 1;
      If copy(Data[Abs(Linie-1)],1,2)='PU' Then  LinieAktiv := 0;
    End;

    If copy(Data[Linie],1,2)='PA' Then Begin;
      If LinieAktiv=0 Then SummeVectU := SummeVectU + VektorDistanz(Data[Linie],DataLast)
                      Else SummeVectD := SummeVectD + VektorDistanz(Data[Linie],DataLast);
    End;
    DataLast := Data[Linie];
    Inc(Linie);
  End;
  Mitteilung.Caption := 'Wegoptimierung luft';

  {Speichern Optimiert in Temp Datei}
  AssignFile(DateiHandel, 'C:\'+TempFileName);
  {$i-}ReWrite(DateiHandel);{$i+}
  If IOResult <> 0 Then Begin;
    ShowMessage('Fehler beim erstellen der Datei: C:\'+TempFileName);
    Exit;
  End;
  WriteLn(DateiHandel,'SP1;');
  WriteLn(DateiHandel,'PU;');
  WriteLn(DateiHandel,'PA0,0;');
  WriteLn(DateiHandel,'PU;');
  LinieStr := 'PA0,0;';
  Repeat;
    Linie := 0;
    DistanzVect := $FFFFFFF;
    DistanzVectPos := 0;
    { Suche krzeste Poli Linie }
    While (Data[Linie]<>'ENDE') And (Data[Abs(Linie-1)]<>'ENDE') And (Linie<=DataMax)do Begin;
      { Poli Linen Anfang Suchen }
      Repeat;
        Inc(Linie);
      Until (Data[Linie-1]='ENDE') Or (Linie>=DataMax) Or(Copy(Data[Linie-1],1,2)='PU') And (Copy(Data[Linie],1,2)='PA');
      { Distanz zu diser Polilinie Rechnen }
      If (VektorDistanz(Data[Linie],LinieStr) < DistanzVect) And
         (VektorDistanz(Data[Linie],LinieStr) > 0) Then Begin;
        DistanzVect := VektorDistanz(Data[Linie],LinieStr);
        DistanzVectPos := Linie;
      End;
    End;
    { Krzeste Poli Linie Schreiben }
    Linie := DistanzVectPos;
    If Linie <>0 Then Begin;
      WriteLn(DateiHandel,'PU;');                                      { Start Poly-Linie }
      Repeat;
        If Data[Linie]<>'' Then WriteLn(DateiHandel,Data[Linie]);
        If Copy(Data[Linie],1,2)='PA' Then LinieStr := Data[Linie];    { Letzte Pos fr Neue Vekt merken }
        If Copy(Data[Linie],1,2)='PA' Then Data[Linie]:='';            { Alle PAs lschen }
        Inc(Linie);
      Until (Copy(Data[Linie],1,2) = 'PU') Or (Data[Linie] = 'ENDE');
      WriteLn(DateiHandel,'PU;');
    End;                                                                { Stop Poly-Linie }
  Until (DistanzVectPos = 0);
  CloseFile(DateiHandel);

  { Temporre Datei laden }
  AssignFile(DateiHandel, 'C:\'+TempFileName);                       {Test if Exist}
  {$i-}Reset(DateiHandel);{$i+}
  If IOResult <> 0 Then Begin;                                       { Fehler abfangen }
    ShowMessage('Fehler beim ffnen von: C:\'+TempFileName);
    Exit;
  End;
  Linie := 0;
  While (Not EOF(DateiHandel)) And (Linie<DataMax) do Begin          { Bis Datei-Ende oder Buffer Ende }
    ReadLn(DateiHandel,Data[Linie]);
    Inc(Linie);
    If Linie Mod 1000 = 0 Then Begin;                       { Alle 1000 Zeilen Windows frei geben }
      Application.ProcessMessages;
      Str(Round(Linie/DataMax*100),LinieStr);
      BuffNutz.Caption := LinieStr+' %';
    End;
  End;
  Inc(Linie);
  Data[Linie]:='ENDE';                                      { Buffer end Merker }
  Str(Round(Linie/DataMax*100),LinieStr);
  BuffNutz.Caption := LinieStr+' %';
  CloseFile(DateiHandel);
  {DrawImg;                                                  { Vektor Bild Zeichnen }

  { Vektoren sumieren Neu!!}
  Linie := 0;
  While (Data[Linie]<>'ENDE') And (Data[Abs(Linie-1)]<>'ENDE') And (Linie<=DataMax) Do Begin;
    If copy(Data[Abs(Linie-1)],1,2)='PA' Then  LinieAktiv := 1;
    While (copy(Data[Linie],1,2)<>'PA') And (Data[Linie]<>'ENDE') And (Linie<=DataMax) Do Begin;
      Inc(Linie);
      If copy(Data[Abs(Linie-1)],1,2)='PD' Then  LinieAktiv := 1;
      If copy(Data[Abs(Linie-1)],1,2)='PU' Then  LinieAktiv := 0;
    End;

    If copy(Data[Linie],1,2)='PA' Then Begin;
      If LinieAktiv=0 Then SummeVectN := SummeVectN + VektorDistanz(Data[Linie],DataLast);
    End;
    DataLast := Data[Linie];
    Inc(Linie);
  End;
  Str(Round(100-(SummeVectD+SummeVectN)/(SummeVectD+SummeVectU)*100),LinieStr);
  Mitteilung.Caption := 'Weg Reduktion: '+LinieStr+ '%';
End;

end.





